<sqtm-core-customisable-dialog
  [titleKey]="
    'sqtm-core.campaign-workspace.dialog.title.automated-tests-execution-supervision'
  "
  [dialogId]="'automated-tests-execution-supervision'"
>
  <sqtm-core-dialog-body>
    @switch (currentBodyLayout$ | async) {
      @case (BodyLayout.LOADING) {
        <ng-container *ngTemplateOutlet="loading"></ng-container>
      }
      @case (BodyLayout.ERROR) {
        <ng-container *ngTemplateOutlet="errorPanel"></ng-container>
      }
      @case (BodyLayout.READY) {
        <ng-container *ngTemplateOutlet="mainPanel"></ng-container>
      }
    }
  </sqtm-core-dialog-body>

  <sqtm-core-dialog-footer>
    @switch (currentFooterLayout) {
      @case (FooterLayout.CONFIRM_OR_CANCEL) {
        <div>
          <button
            [attr.data-test-dialog-button-id]="'confirm'"
            [disabled]="!(areAllPreviewsLaunchable$ | async)"
            nz-button
            nzType="primary"
            (click)="confirmSelectServerStep()"
          >
            {{ 'sqtm-core.generic.label.confirm' | translate }}
          </button>
          <button
            class="m-l-5"
            [attr.data-test-dialog-button-id]="'cancel'"
            nz-button
            nzType="default"
            sqtmCoreDialogClose
          >
            {{ 'sqtm-core.generic.label.cancel' | translate }}
          </button>
        </div>
      }
      @case (FooterLayout.CLOSE_SIMPLE) {
        <div>
          <button
            class="m-l-5"
            [attr.data-test-dialog-button-id]="'close'"
            (click)="closeExecutionPhase()"
            nz-button
            nzType="default"
          >
            {{ 'sqtm-core.generic.label.close' | translate }}
          </button>
        </div>
      }
      @case (FooterLayout.CLOSE_WARNING) {
        <div>
          <button
            [attr.data-test-dialog-button-id]="'confirm'"
            nz-button
            nzType="primary"
            (click)="confirmCloseExecutionPhase()"
          >
            {{ 'sqtm-core.generic.label.confirm' | translate }}
          </button>
          <button
            class="m-l-5"
            [attr.data-test-dialog-button-id]="'cancel'"
            nz-button
            nzType="default"
            (click)="resumeExecutionPhase()"
          >
            {{ 'sqtm-core.generic.label.cancel' | translate }}
          </button>
        </div>
      }
    }
  </sqtm-core-dialog-footer>
</sqtm-core-customisable-dialog>

<ng-template #mainPanel>
  @switch (currentFooterLayout) {
    @case (FooterLayout.CONFIRM_OR_CANCEL) {
      <div class="p-5">
        <sqtm-core-banner-with-navigation-link
          [messageKey]="
            'sqtm-core.administration-workspace.system.settings.callback-url.missing-callback-url-banner.message'
              | translate
          "
          [linkKey]="
            'sqtm-core.administration-workspace.system.settings.callback-url.missing-callback-url-banner.message-link'
              | translate
          "
          [permissionKey]="
            'sqtm-core.administration-workspace.system.settings.callback-url.missing-callback-url-banner.permission-warning'
              | translate
          "
          [redirectionUrl]="defineRedirectionUrl()"
          [isVisible]="shouldShowCallbackUrlBanner()"
        >
        </sqtm-core-banner-with-navigation-link>
        @for (
          squashAutomProject of configuration.squashAutomProjects;
          track squashAutomProject
        ) {
          <sqtm-app-squash-autom-project-preview
            [squashAutomProject]="squashAutomProject"
            [formGroup]="squashAutomProjectsFormGroup"
            [iterationId]="specification.iterationId"
            [attr.data-test-element-id]="
              'squash-autom-' + squashAutomProject.projectId
            "
          >
          </sqtm-app-squash-autom-project-preview>
        }
        @for (
          automationProject of configuration.projects;
          track automationProject
        ) {
          <sqtm-app-automation-project-menu
            [automationProject]="automationProject"
            [specification]="configuration.specification"
            [formGroup]="jenkinsProjectsFormGroup"
            [attr.data-test-element-id]="automationProject.projectId"
          >
          </sqtm-app-automation-project-menu>
        }
      </div>
    }
    @case (FooterLayout.CLOSE_SIMPLE) {
      <div class="p-5">
        <sqtm-app-tf-execution-table
          [dataRows]="tfExecutionDataRows"
          [progress]="tfExecutionProgress"
        >
        </sqtm-app-tf-execution-table>
        <sqtm-app-squash-autom-execution-table
          [dataRows]="squashAutomExecutionDataRows"
          [progress]="squashAutomExecutionProgress"
        >
        </sqtm-app-squash-autom-execution-table>
        <div>
          @switch (statusIcon) {
            @case ('DANGER') {
              <div class="flex">
                <i
                  nz-icon
                  class="sqtm-core-icon"
                  nzType="exclamation-circle"
                  nzTheme="twotone"
                  [nzTwotoneColor]="'#FF0000'"
                ></i>
                <div [innerHTML]="errorMessage"></div>
              </div>
            }
            @case ('INFO') {
              <div>
                <div class="flex">
                  <i
                    nz-icon
                    class="sqtm-core-icon"
                    nzType="info-circle"
                    nzTheme="twotone"
                    [nzTwotoneColor]="'#1890FF'"
                  ></i>
                  <div
                    [innerHTML]="
                      'sqtm-core.campaign-workspace.dialog.message.automated-tests-execution-supervision.orchestrator-received-workflow-success'
                        | translate
                    "
                  ></div>
                </div>
                <div class="workflows-uuids">
                  @for (uuid of workflowsUuids; track uuid) {
                    <ul>
                      <li>{{ uuid }}</li>
                    </ul>
                  }
                </div>
              </div>
            }
          }
        </div>
      </div>
    }
    @case (FooterLayout.CLOSE_WARNING) {
      <div class="p-5">
        <div class="flex-row close-warning-content">
          <i
            nz-icon
            class="sqtm-core-icon"
            nzType="exclamation-circle"
            nzTheme="twotone"
            [nzTwotoneColor]="'#FAAD14'"
          >
          </i>
          <span
            [innerHTML]="
              'sqtm-core.campaign-workspace.dialog.message.automated-tests-execution-supervision.close-warning'
                | translate
            "
          >
          </span>
        </div>
      </div>
    }
  }
</ng-template>

<ng-template #loading>
  <div class="full-height full-width">
    <sqtm-core-full-page-loading-icon></sqtm-core-full-page-loading-icon>
  </div>
</ng-template>

<ng-template #errorPanel>
  <div class="flex-row m-t-5 align-items-center">
    <i
      nz-icon
      class="sqtm-core-icon"
      nzType="exclamation-circle"
      nzTheme="twotone"
      [nzTwotoneColor]="'#FF0000'"
    ></i>
    <span
      class="error-message red height-fit-content"
      [innerHTML]="
        'sqtm-core.user-account-page.api-token.no-jwt-secret' | translate
      "
    ></span>
  </div>
</ng-template>
